<template>
  <div id="enrollment-finish-list-wrapper">
    <el-button icon="el-icon-refresh" :key="refreshDisable" style="float: right; margin-right: 20px;" type="success"
      @click="$listeners['refreshAllList']()" :disabled="refreshDisable">{{ $t('TEACHER_CLASS.REFRESH') }}</el-button>
    <span style="float: right; margin-right: 20px; line-height: 250%;" v-if="refreshCountDown > 0">{{ $t('TEACHER_CLASS.TRY_AFT', { time: refreshCountDown }) }}</span>
    <el-table :data="finishList" class="elTable-label" @selection-change="handleSelectionChange" :empty-text="$t('ENROLL_TABLE.EMPTY_DATA')">
      <el-table-column
        ref="multipleTable"
        type="selection"
        align="center">
      </el-table-column>

      <el-table-column
        type="index"
        width="50">
      </el-table-column>

      <el-table-column
        prop="email_id"
        :label="$t('TEACHER_CLASS.EMAIL')"
        align="left"
      ></el-table-column>

      <el-table-column
        prop="name"
        :label="$t('TEACHER_CLASS.NAME')"
        width="200"
        align="left"
      ></el-table-column>

      <el-table-column
        prop="enrollments.updated_at"
        :label="$t('TEACHER_CLASS.ACCEPT_TIME')"
        width="300"
        align="left"
      ></el-table-column>

      <el-table-column
        label="-"
        width="125"
        align="center"
      >
        <template slot-scope="scope">
          <el-button type="danger" @click="deleteStudent(scope.row)" class="delete-btn">{{ $t('TEACHER_CLASS.EXCEPT') }}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <div class="selection_btns">
      <el-button type="danger" @click="selection('delete')" class="delete-btn">{{ $t('TEACHER_CLASS.SEL_EXCEPT') }}</el-button>
      <el-button :class="$attachReactablePostfix('right-align-btn')" type="primary" @click="onClick('INPUT_CLICK')" style="width: 12%; float: right;">
        <div class="right-align-btn-layer">{{ $t('LECTURE_LIST.ERLL_STD') }}</div>
        <input id="student_add_input" style="display: none;" @change="onClick('ADD_STUDENT')" type="file">
      </el-button>
      <a :href="downloadLink" download="proposed_file_name">
        <el-button :class="$attachReactablePostfix('right-align-btn')" style="width: auto; float: right;">
          {{ $t('LECTURE_LIST.DOWNLOAD_FORM') }}
        </el-button>
      </a>        
    </div>
  </div>
</template>

<script>
import { baseUrl } from '../../services/config';
import userService from '../../services/userService';
import utils from '../../utils';
import authService from '../../services/authService';
import classService from '../../services/classService';
import enrollmentService from '../../services/enrollmentService';

export default {
  name: 'EnrollmentFinishList',
  props: {
    finishList: {
      type: Array
    },
    refreshDisable: {
      type: Boolean
    },
    refreshCountDown: {
      type: Number
    },
    classId: {
      type: Number
    }
  },
  data() {
    return {
      downloadLink: `${baseUrl}/downloads/studentListForm`,
      multipleSelection: [],
      code: '',
    };
  },
  mounted() {
    const vm = this;
    vm.$listeners['refreshFinishList']();
  },
  // computed: {
  //   classId() {
  //     const vm = this;
  //     return Number.parseInt(vm.$route.params.classId, 10);
  //   },
  // },
  mounted() {
    const vm = this;
    vm.$listeners['refreshFinishList']();
  },
  methods: {
    handleSelectionChange(val) {
      const vm = this;
      vm.multipleSelection = val;
    },
    deleteStudent(data) {
      const vm = this;
       vm.$confirm(vm.$t('TEACHER_CLASS.EXCEPT_STUDENT_QUES', { name: data.name }), vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'), {
        confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
        cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
        type: 'warning',
      }).then(async () => {
      vm.$confirm(vm.$t('TEACHER_CLASS.EXCEPT_STUDENT_QUES2', { name: data.name }), vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'), {
        confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
        cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
        type: 'warning',
      }).then(async () => {
        const deleteResult = await userService.deleteUserClasses({
          classId: vm.classId,
          userId: data.user_id,
        });
        if(deleteResult.data.success == true) //choi -->
        {
          const delete_log_create = await userService.createUserClassesDeletelog({
            classId: vm.classId,
            userId: data.user_id,
          });
        }
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'),
          message: vm.$t('TEACHER_CLASS.EXCEPT_STUDENT_MSG', { name: data.name }),
          duration: 3000,
          type: 'success',
        });
        vm.$listeners['refreshFinishList']();
      }).catch((err) => {
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'),
          message: vm.$t('TEACHER_CLASS.EXCEPT_STUDENT_CANCEL'),
          duration: 3000,
          type: 'warning',
        });
      });
      })
    },
    selection(type) {
      const vm = this;
      if (vm.multipleSelection.length === 0) {
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.SEL_ERROR'),
          message: vm.$t('TEACHER_CLASS.SEL_ERROR_MSG'),
          duration: 3000,
          type: 'warning',
        })
        return;
      }
      switch (type) {
        case 'delete': {
          vm.$confirm(vm.$t('TEACHER_CLASS.EXCEPT_MUL_STUDENT_QUES', { num: vm.multipleSelection.length }), vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'), {
            confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
            cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
            type: 'warning',
          }).then(async () => {
          vm.$confirm(vm.$t('TEACHER_CLASS.EXCEPT_MUL_STUDENT_QUES2', { num: vm.multipleSelection.length }), vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'), {
            confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
            cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
            type: 'warning',
          }).then(async () => {
            const promiseTodo = [];
            vm.multipleSelection.forEach((selection) => {
              promiseTodo.push(userService.deleteUserClasses({
                classId: vm.classId,
                userId: selection.user_id,
              }));
              userService.createUserClassesDeletelog({
                classId: vm.classId,
                userId: selection.user_id,                
              });
            });
            Promise.all(promiseTodo).then((result) => {
              vm.$notify({
                title: vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'),
                message: vm.$t('TEACHER_CLASS.EXCEPT_MUL_STUDENT_MSG', { num: vm.multipleSelection.length }),
                duration: 3000,
                type: 'success',
              });
              vm.$listeners['refreshFinishList']();
            });
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('TEACHER_CLASS.EXCEPT_STUDNET'),
              message: vm.$t('TEACHER_CLASS.EXCEPT_STUDENT_CANCEL'),
              duration: 3000,
              type: 'warning',
            });
          });
          });
          break;
        }
      }
    },
    async onClick(type) {
      const vm = this;
      const userId = utils.getUserIdFromJwt();
      switch (type) {
        case 'INPUT_CLICK': {
          // window.location.assign('\materials\f356e97f-b6a2-c611-697c-395d96da97bb\학생 계정 생성 양식.csv');
          document.getElementById('student_add_input').click();
          break;
        }
        case 'ADD_STUDENT': {
          const targetFile = document.getElementById('student_add_input').files[0];
          // 업로드하는 파일이 csv 파일인지 검사
          var allowedExtension = /(\.csv)$/i;
          if(!allowedExtension.exec(targetFile.name)) {
            vm.$notify({
                      title: vm.$t('NOTIFY.FAIL_REG_STD'),
                      message: vm.$t('NOTIFY.UPLOAD_VALID_FORM'),
                      type: 'error',
                      duration: 3000,
                    });
            return;        
          }
          const reader = new FileReader();
          vm.exceptList = [];

          // 파일이 읽혀 졌으면 event listener 등록
          reader.onload = (event) => {
            // excel 파일 추출
            const excelDatas = reader.result.split('\n').filter(item => item.split(',')[0] !== '' && item.split(',')[1] !== '' && item.split(',')[0] !== '이메일');
            const emails = excelDatas.map(data => data.split(',')[0]);
            const names = excelDatas.map(data => data.split(',')[1]);
            let promiseToDo = [];
            let promiseToDo2 = [];
            // 학생 이메일이 이미 존재하는지 확인
            emails.forEach(async (email) => {
              promiseToDo.push(userService.searchUserByEmail({ email }));
            });

            Promise.all(promiseToDo).then((result) => {
              promiseToDo = [];
              // 강의 등록 명단에 추가
              result.forEach(async (userData) => {
                if (userData.data.length > 0) {
                  promiseToDo2.push(classService.postClassUserByTeacher({
                    classId: vm.classId,
                    userId: userData.data[0].user_id,
                  }));
                  const resExcel = await enrollmentService.postEnrollmentExcel({
                    class_id: vm.classId,
                    user_id: userData.data[0].user_id,
                  });
                  // 소속 등록하기
                  const class_belonging = await classService.getClassBelongingByClassId({ classId: vm.classId });
                  if (class_belonging.data.result.length > 0) {
                    const belongingAdd = await userService.postUserBelongingExcel({
                      code: class_belonging.data.result[0].belonging_pwd,
                      user_id: userData.data[0].user_id,
                    });
                  }
                } else {
                  const email = userData.request.responseURL.split('email=')[1];
                  const name = (excelDatas.filter(item => item.includes(email))[0].split('\r')[0])
                  .split('"').join('').split(',').slice(1).filter(item => item !== "").join(',');
                  const password = 'test';
                  // 이메일 32자 초과하는것 제외
                  if (email.length <= 32) {
                    // 회원가입
                    promiseToDo.push(authService.register({
                      input: {
                        email_id: email,
                        password,
                        name,
                      }
                    }));
                  } else {
                    vm.exceptList.push({
                      email,
                      name,
                    });
                  }
                }
              });

              // 회원가입이 됬으면 강의 수강 등록
              Promise.all(promiseToDo).then((result1) => {
                // 강의 등록 명단에 추가
                result1.forEach(async (userData) => {
                  promiseToDo2.push(classService.postClassUserByTeacher({
                    classId: vm.classId,
                    userId: userData.data.user_id,
                  }));
                  const response = await enrollmentService.postEnrollmentExcel({
                    class_id: vm.classId,
                    user_id: userData.data.user_id,
                  });
                  // 소속 등록하기
                  const class_belonging = await classService.getClassBelongingByClassId({ classId: vm.classId });
                  if (class_belonging.data.result.length > 0) {
                    const belongingAdd = await userService.postUserBelongingExcel({
                      code: class_belonging.data.result[0].belonging_pwd,
                      user_id: userData.data[0].user_id,
                    });
                  }
                });
                Promise.all(promiseToDo2).then(async (result2) => {
                  if (vm.exceptList.length > 0) {
                    vm.exceptionDialogVisible = true;
                  } else {
                    vm.$notify({
                      title: vm.$t('NOTIFY.TITLE'),
                      message: vm.$t('NOTIFY.STD_REG_CMPLT'),
                      type: 'success',
                      duration: 3000,
                    });
                  }
                  vm.$listeners['refreshAllList']();
                });
                vm.$listeners['refreshAllList']();
              });
            });
          }
          // 파일 읽는 부분
          reader.readAsText(targetFile, "euc-kr");
          // 파일 내용 초기화
          document.getElementById('student_add_input').value = "";
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
};
</script>

<style  lang="scss" scoped>
#enrollment-finish-list-wrapper{
  .selection_btns {
    margin-top: 10px;
  }
  .right-align-btn {
    width: 100%;
    height: 40px;
    border-radius: 3px;
    border: solid 1px #1989fa;
  }
  .right-align-btn-layer {
    width: 94px;
    height: 12px;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
    margin-left: auto;
    margin-right: auto;
  }
}
</style>